"	NAME		X-cache
	AUTHOR		S. Walther <walther@caip.rutgers.edu>
	FUNCTION	Cache contents of ScheduledWindow in X (in C)
	ST-VERSION	R4.0
	PREREQUISITES	
	CONFLICTS	
	DISTRIBUTION	world
	VERSION	R	1
	DATE	 	Dec 1991
SUMMARY
This is the C source for a user primitive.

From: peskin@cesl.rutgers.edu ( R. Peskin)
Newsgroups: comp.lang.smalltalk
Subject: Re: X window caching in PPS 4.0
Message-ID: <Dec.19.17.12.00.1991.7167@cesl.rutgers.edu>
Date: Thu, 19 Dec 91 22:12:00 GMT
Organization: Rutgers Univ., New Brunswick, N.J.

The  following code sets a window that has already been opened by
the methods in ScheduledWindow to cache its contents and restore
from cache when damaged.  Install the code as a User Primitive using the 
makefile supplied by ParcPlace.  (see documentation for adding User 
Primitives).
"

'
/*		X window caching
*/

#include <X11/Xlib.h>
#include <stdio.h>
#include "userprim.h"


makeWindowCachable(ToolWindow,theDisplay,theWindow)
upHandle ToolWindow;
upHandle theDisplay,theWindow;
{
	Display *display;
	Window window;
	XSetWindowAttributes setwinattr;
	unsigned long valuemask;

	display = UPSTtoCint(theDisplay);
	window = (Window)UPSTtoCint(theWindow);
	valuemask = CWBackingStore | CWBackingPlanes;
	setwinattr.backing_store = Always;
	setwinattr.backing_planes = (long)8;  /*  assumes color */
	XChangeWindowAttributes(display,window,valuemask,&setwinattr);
	UPreturnTrue();
}
'

"To invoke this primitive selectively, we  subclassed ToolWindow off 
ScheduledWindow and installed the Smalltalk method that calls the 
primitive in that class as an instance method ( makeWindowCachable: 
displayID window: windowID).  We copied the relevant open method from 
Scheduled Window (PrivateOpenIn: aRectangle type: windowType) into 
ToolWindow and added the method to call our primitive after all the 
standard window opening work was done.  The display ID is obtained by the 
code ""Screen default key"" and the window ID by the code ""self key"" where 
self is the instance of ToolWindow being opened.  The call to the primitive 
is :

self makeWindowCachable: (Screen default key) windowID: (self key).


This has solved our problem of lengthy redisplaying whenever a graphics 
view is touched.  We are running on Sparcs with 16Mb to 32Mb memory and 
have been able to open quite a few (10 or so) cached windows at a time 
without noticing any performance degradation.  If you have less memory, you 
might need to use caching more selectively.

Code written by S. Walther <walther@caip.rutgers.edu>

--dick peskin
"
